LRESULT CALLBACK LCDTest_WndProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK SizeMeter_WndProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam);

class CIcon : public CWindow
{
public:
	CIcon(LPCTSTR name, LPCTSTR id) {
		lstrcpy(this->name, name);
		lstrcpy(this->id, id);
	}

	TCHAR name[32];
	TCHAR id[32];
};

class CLCDTest : public CIcon
{
public:
	HWND hBtn;
	CLCDTest(int order, LPCTSTR name, LPCTSTR id) : CIcon(name, id) {
	}

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam) {
		hBtn = CreateWindow(TEXT("GrpBtn"), NULL, WS_CHILD | WS_VISIBLE | GBS_PUSH,
			0, 0, iconSize, iconSize, hWnd, (HMENU)1, g_hInst, NULL);
		SendMessage(hBtn, GBM_SETIMAGE, MAKEWPARAM(IDB_LCD_NOR, IDB_LCD_NOR),
			MAKEWPARAM(IDB_LCD_NOR, IDB_LCD_NOR));

		WNDCLASS WndClass;
		WndClass.cbClsExtra = 0;
		WndClass.cbWndExtra = 0;
		WndClass.hbrBackground = NULL;
		WndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
		WndClass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
		WndClass.hInstance = g_hInst;
		WndClass.lpfnWndProc = LCDTest_WndProc;
		WndClass.lpszClassName = L"LCDTest";
		WndClass.lpszMenuName = NULL;
		WndClass.style = CS_HREDRAW | CS_VREDRAW;
		RegisterClass(&WndClass);
		return 0;
	}

	LRESULT OnCommand(WPARAM wParam, LPARAM lParam) {
		if (LOWORD(wParam) == 1) {
			//   輱 . 콺 Ŀ . IME  
			//  ī     . Ƽ      ִ. 
			CreateWindowEx(WS_EX_TOPMOST, L"LCDTest", L"LCDTest", WS_POPUP | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
				hWnd, (HMENU)NULL, g_hInst, NULL);
		}
		return 0;
	}
};

class CSizeMeter : public CIcon
{
public:
	HWND hBtn;
	CSizeMeter(int order, LPCTSTR name, LPCTSTR id) : CIcon(name, id) {
	}

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam) {
		hBtn = CreateWindow(TEXT("GrpBtn"), NULL, WS_CHILD | WS_VISIBLE | GBS_PUSH,
			0, 0, iconSize, iconSize, hWnd, (HMENU)1, g_hInst, NULL);
		SendMessage(hBtn, GBM_SETIMAGE, MAKEWPARAM(IDB_SIZE_NOR, IDB_SIZE_NOR),
			MAKEWPARAM(IDB_SIZE_NOR, IDB_SIZE_NOR));

		WNDCLASS WndClass;
		WndClass.cbClsExtra = 0;
		WndClass.cbWndExtra = 0;
		WndClass.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
		WndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
		WndClass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
		WndClass.hInstance = g_hInst;
		WndClass.lpfnWndProc = SizeMeter_WndProc;
		WndClass.lpszClassName = L"SizeMeter";
		WndClass.lpszMenuName = NULL;
		WndClass.style = CS_HREDRAW | CS_VREDRAW;
		RegisterClass(&WndClass);
		return 0;
	}

	LRESULT OnCommand(WPARAM wParam, LPARAM lParam) {
		if (LOWORD(wParam) == 1) {
			CreateWindow(L"SizeMeter", L"SizeMeter", WS_OVERLAPPEDWINDOW | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
				NULL, (HMENU)NULL, g_hInst, NULL);
		}
		return 0;
	}
};

class CMoveCursor : public CIcon
{
public:
	HWND hBtn;
	bool bCursorMove;			// Ŀ  ̵ 
	int TimerInterval;			// Ÿ̸ ֱ
	int CursorInterval;			// Ŀ  ̵ ֱ(ʴ)
	int CursorKeepSec;			// Ŀ  ʰ  ڸ ־ ð
	int RejectCount;			// Ŀ ̵ ȸ(ũ ̹  ȸ)
	POINT OldCursorPt;			//  Ŀ ġ
	CMoveCursor(int order, LPCTSTR name, LPCTSTR id) : CIcon(name, id) {
	}

	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam) {
		KillTimer(hWnd, 1);
		return 0;
	}

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnCommand(WPARAM wParam, LPARAM lParam);
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	LRESULT OnContextMenu(WPARAM wParam, LPARAM lParam);
};


